<?php

/**
 * Class NewTrustedShopsAjaxController
 */
class NewTrustedShopsAjaxController extends AbstractModuleCenterModuleController
{
    /**
     * @var
     */
    protected $db;

    /**
     *
     */
    protected function _init()
    {
        $this->db = StaticGXCoreLoader::getDatabaseQueryBuilder();
        return;
    }

    /**
     * @return AdminPageHttpControllerResponse|RedirectHttpControllerResponse|void
     */
    public function actionDefault()
    {
        return;
    }

    /**
     *
     */
    public function actionGetTrustedShopsId()
    {
        $response = [];

        if($this->isPost() and $this->isXmlHttpRequest()) {
            $trustedShopsId = '';
            $locale         = $_POST['locale'];

            try {
                $result = $this->db->query("SELECT trustedshops_id FROM `trustedshops_configuration` WHERE trustedshops_locale='" . $locale ."'")->result_array();

                if (isset($result) and empty($result) === false) {
                    $trustedShopsId = $result[0]['trustedshops_id'];
                }

                $response = [
                    'trustedShopsId' => $trustedShopsId
                ];
            } catch (Exception $exception) {
                $response = AjaxException::response($exception);
            }
        }

        return MainFactory::create('JsonHttpControllerResponse', $response);
    }

    /**
     *
     */
    public function actionSetLocale()
    {
        $response = [];

        if($this->isPost() and $this->isXmlHttpRequest()) {
            $locale = $_POST['locale'];

            $_SESSION['trustedshops_locale'] = filter_var(htmlspecialchars($locale), FILTER_SANITIZE_STRING);

            $response = ['trustedshops_locale' => $_SESSION['trustedshops_locale']];
        }

        return MainFactory::create('JsonHttpControllerResponse', $response);
    }

    /**
     * @return bool
     */
    private function isPost()
    {
        if($_SERVER['REQUEST_METHOD'] === 'POST') {
            return true;
        }

        return false;
    }

    /**
     * @return bool
     */
    private function isXmlHttpRequest()
    {
        if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            return true;
        }

        return false;
    }
}
